// Code generated by client-gen. DO NOT EDIT.

package v1beta2

import (
	"context"
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
	v1beta2 "px.dev/pixie/src/operator/apis/etcd.database.coreos.com/v1beta2"
	scheme "px.dev/pixie/src/operator/vendored/etcd/scheme"
)

// EtcdBackupsGetter has a method to return a EtcdBackupInterface.
// A group's client should implement this interface.
type EtcdBackupsGetter interface {
	EtcdBackups(namespace string) EtcdBackupInterface
}

// EtcdBackupInterface has methods to work with EtcdBackup resources.
type EtcdBackupInterface interface {
	Create(ctx context.Context, etcdBackup *v1beta2.EtcdBackup, opts v1.CreateOptions) (*v1beta2.EtcdBackup, error)
	Update(ctx context.Context, etcdBackup *v1beta2.EtcdBackup, opts v1.UpdateOptions) (*v1beta2.EtcdBackup, error)
	UpdateStatus(ctx context.Context, etcdBackup *v1beta2.EtcdBackup, opts v1.UpdateOptions) (*v1beta2.EtcdBackup, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta2.EtcdBackup, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta2.EtcdBackupList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.EtcdBackup, err error)
	EtcdBackupExpansion
}

// etcdBackups implements EtcdBackupInterface
type etcdBackups struct {
	client rest.Interface
	ns     string
}

// newEtcdBackups returns a EtcdBackups
func newEtcdBackups(c *EtcdV1beta2Client, namespace string) *etcdBackups {
	return &etcdBackups{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the etcdBackup, and returns the corresponding etcdBackup object, and an error if there is any.
func (c *etcdBackups) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta2.EtcdBackup, err error) {
	result = &v1beta2.EtcdBackup{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("etcdbackups").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of EtcdBackups that match those selectors.
func (c *etcdBackups) List(ctx context.Context, opts v1.ListOptions) (result *v1beta2.EtcdBackupList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta2.EtcdBackupList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("etcdbackups").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested etcdBackups.
func (c *etcdBackups) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("etcdbackups").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a etcdBackup and creates it.  Returns the server's representation of the etcdBackup, and an error, if there is any.
func (c *etcdBackups) Create(ctx context.Context, etcdBackup *v1beta2.EtcdBackup, opts v1.CreateOptions) (result *v1beta2.EtcdBackup, err error) {
	result = &v1beta2.EtcdBackup{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("etcdbackups").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(etcdBackup).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a etcdBackup and updates it. Returns the server's representation of the etcdBackup, and an error, if there is any.
func (c *etcdBackups) Update(ctx context.Context, etcdBackup *v1beta2.EtcdBackup, opts v1.UpdateOptions) (result *v1beta2.EtcdBackup, err error) {
	result = &v1beta2.EtcdBackup{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("etcdbackups").
		Name(etcdBackup.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(etcdBackup).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *etcdBackups) UpdateStatus(ctx context.Context, etcdBackup *v1beta2.EtcdBackup, opts v1.UpdateOptions) (result *v1beta2.EtcdBackup, err error) {
	result = &v1beta2.EtcdBackup{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("etcdbackups").
		Name(etcdBackup.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(etcdBackup).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the etcdBackup and deletes it. Returns an error if one occurs.
func (c *etcdBackups) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("etcdbackups").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *etcdBackups) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("etcdbackups").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched etcdBackup.
func (c *etcdBackups) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.EtcdBackup, err error) {
	result = &v1beta2.EtcdBackup{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("etcdbackups").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
